% plot_omtgrid 

function distance = plot_omtgrid( varargin )


if ~isempty(varargin)
    
%     disp(['Ready plot location result'])
    
    Positions = varargin{1}; %     disp(['Candidate Grid'])
    transmitterpos = varargin{2}; %     
    receiverpos      = varargin{3}; %  
    targetpos         = varargin{4}; %  
    Nrx = varargin{5};          %     disp(['Number of receiver'])
    Ntarget = varargin{6};   %     disp(['Number of target'])
    estimate = varargin{7};  %     disp(['Estimate location'])
else 
    disp(['PlotLocationResult is error'])
    pause
end

ms = 6;
estpos = estimate;

%%
% figure
htrans = plot3(transmitterpos(1,:),transmitterpos(2,:),transmitterpos(3,:),'sk', 'MarkerSize',ms, 'LineWidth', 1.5);
hold on
%
hres = plot3(receiverpos(1,:),receiverpos(2,:),receiverpos(3,:),'vk', 'MarkerSize',ms, 'LineWidth', 1.5);  
hold on
%
htarget = plot3(targetpos(1,:),targetpos(2,:),targetpos(3,:),'om', 'MarkerSize',ms, 'LineWidth', 1.5);
hold on
%
hgrid = plot3(Positions(1,:),Positions(2,:),Positions(3,:),'g.');
hold on
%
set(gca, 'ZDir', 'reverse'), grid on
%
hvec1 = [htrans,hres,htarget,hgrid]';        
strcell1 = {'transmitter','receivers','targets','grid'};
legend(hvec1,strcell1);
xlabel('x-pos'),ylabel('y-pos'),zlabel('z-pos')


%  ------------ 
if  ~isempty(estpos)
    hest = plot3(estpos(1,:),estpos(2,:),estpos(3,:),'k+', 'MarkerSize',ms, 'LineWidth', 1.5);
    hvec1 = [htrans,hres,htarget,hgrid,hest]';        
    strcell1 = {'transmitter','receivers','targets','grid','estimate'};
    legend(hvec1,strcell1);
    xlabel('x-pos'),ylabel('y-pos'),zlabel('z-pos')

%  ------------ Calculate rmse
for ell = 1:size(estpos,2)
    e(ell,:) = vecnorm( targetpos(:,ell)-estpos ) ./ norm(targetpos(:,ell));
    dis(ell,:) = vecnorm( targetpos(:,ell)-estpos );
end

rmse = [min(e,[],2) ]
distance = [min(dis,[],2)]
% disp ( 'distance error = ',num2str(distance'),'m' )

end

axis equal;

end